	org $1001-2
	dw  $1001
	
rand		= $D0
chr_ptr		= $D4
col_ptr		= $D6
menu_ptr	= $D8
boardsize	= $E0
tmpx		= $E1
tmpy		= $E2
board_x		= $E3
board_y		= $E4
cursor_x	= $E5
cursor_y	= $E6
sum		= $E7

keyb_ptr		= $DA	; zeropage variable (16 bits)
keyb_lastkey		= $DC	; zeropage variable (8 bits)
keyb_repeatcnt		= $DD	; zeropage variable (8 bits)
keyb_shift		= $DE	; zeropage variable (8 bits)
keyb_repeat_init	= 20	; constant
keyb_repeat		= 4	; constant

COLORMEM		= $0800
CHARMEM			= $0C00
MENU_POS		= COLORMEM+40*8+13

BORDER_COLOR		= $36
INCORRECT_SUM_COLOR	= $41
CORRECT_SUM_COLOR	= $00
CONGRATS_COLOR		= $05  
MENU_COLOR		= $71
SELECTED_MENU_COLOR	= $59
INFO_COLOR		= $6D
	
	dw nextln,0	; second word is line number
	db $9E,"4109",0
nextln	db 0,0
	
start
	sei
	sta $FF3F
	cld
	;
	jsr InitRandom
	;
	lda #MENU_POS & 255			; init menu item
	sta menu_ptr
	lda #MENU_POS >> 8
	sta menu_ptr+1
	lda #2
	sta boardsize
	;
menu	
	ldx #$FF				; sync to bottom of frame ($FF on PAL, $F8 on NTSC)
	lda $FF07
	and #$40
	beq *+4
	ldx #$F8
	cpx $FF1D
	bne *-3
	;
	lda #$67				; screen off, set up all TED registers
	sta $FF19
	lda #$0B				
	sta $FF06
	lda #$00
	sta $FF15
	;
	lda $FF07
	and #$40
	ora #$88
	sta $FF07
	;
	lda $FF12
	and #$03
	ora #$C0
	sta $FF12
	lda #font >> 8
	sta $FF13
	;
	ldy #$67
	jsr ClearScreen
	;
	jsr CopyLogo
	;
	ldx #13
il3	lda menu_text+0*14,x
	sta CHARMEM+40*8+13,x
	lda menu_text+1*14,x
	sta CHARMEM+40*9+13,x
	lda menu_text+2*14,x
	sta CHARMEM+40*10+13,x
	lda menu_text+3*14,x
	sta CHARMEM+40*11+13,x
	lda menu_text+4*14,x
	sta CHARMEM+40*12+13,x
	lda menu_text+5*14,x
	sta CHARMEM+40*13+13,x
	lda menu_text+6*14,x
	sta CHARMEM+40*14+13,x
	lda menu_text+7*14,x
	sta CHARMEM+40*15+13,x
	lda #MENU_COLOR
	sta COLORMEM+40*7+13,x
	sta COLORMEM+40*8+13,x
	sta COLORMEM+40*9+13,x
	sta COLORMEM+40*10+13,x
	sta COLORMEM+40*11+13,x
	sta COLORMEM+40*12+13,x
	sta COLORMEM+40*13+13,x
	sta COLORMEM+40*14+13,x
	sta COLORMEM+40*15+13,x
	sta COLORMEM+40*16+13,x
	dex
	bpl il3
	;
	ldx #9
il5	lda copyright,x
	sta CHARMEM+40*24+15,x
	dex
	bpl il5 
	;
	jsr HighlightMenuItem
	;
	jsr wait_for_key_release
	;
	lda #$CC				; sync to bottom of screen
	cmp $FF1D
	bne *-3
	;
	lda #$1B				; screen on (normal mode)
	sta $FF06
	;
menu_loop
	lda #menu_key_table & 255
	ldx #menu_key_table >> 8
	jmp keyboard

ClearScreen
	ldx #$00
cls1	tya
	sta COLORMEM+$0000,x
	sta COLORMEM+$0100,x
	sta COLORMEM+$0200,x
	sta COLORMEM+$0300,x
	lda #$40
	sta CHARMEM+$0000,x
	sta CHARMEM+$0100,x
	sta CHARMEM+$0200,x
	sta CHARMEM+$0300,x
	inx
	bne cls1
	rts
 
CopyLogo
	ldx #25
il4	lda charmap+0*26,x
	sta CHARMEM+0*40+7,x
	lda charmap+1*26,x
	sta CHARMEM+1*40+7,x
	lda charmap+2*26,x
	sta CHARMEM+2*40+7,x
	lda charmap+3*26,x
	sta CHARMEM+3*40+7,x
	lda charmap+4*26,x
	sta CHARMEM+4*40+7,x
	dex
	bpl il4
	rts

new_game
	ldx #$FF				; sync to bottom of frame ($FF on PAL, $F8 on NTSC)
	lda $FF07
	and #$40
	beq *+4
	ldx #$F8
	cpx $FF1D
	bne *-3
	;
	lda #$0B
	sta $FF06				; screen off
	;
	lda #$61
	sta $FF19
	sta $FF16
	lda #$71
	sta $FF15
	lda #$66
	sta $FF17
	;
	ldx #$00
	lda #$60
il1	sta $0C00,x
	sta $0D00,x
	sta $0E00,x
	sta $0F00,x
	inx
	bne il1
	;
	jsr ClearBoard
	;
	ldx boardsize	
	lda board_xs,x
	sta board_x
	lda board_ys,x
	sta board_y
	lda #0
	sta cursor_x
	sta cursor_y
	;
	jsr GenerateBoard
	;
	jsr SumColumns
	jsr SumRows
	;
	jsr DrawBorder
	jsr DisplayBoard
	;
	jsr DrawCursor
	;
	jsr wait_for_key_release
	;
	lda #$CC				; sync to bottom of screen
	cmp $FF1D
	bne *-3
	;
	lda #$5B
	sta $FF06				; screen on (ECM mode)
	;
main_loop
	jsr CheckWin
	beq win
	;
	lda #game_key_table & 255
	ldx #game_key_table >> 8
	jmp keyboard

win
	jsr wait_for_key_release
	;
	ldx #$FF				; sync to bottom of frame ($FF on PAL, $F8 on NTSC)
	lda $FF07
	and #$40
	beq *+4
	ldx #$F8
	cpx $FF1D
	bne *-3
	;
	lda #$55				; border and ECM to green
	sta $FF19
	sta $FF16
	;
	jsr ClearCursor
	;
	ldx #$00
w1	txa
	clc
	adc #$61
	sta $0FCC,x				; write "congratulations" on screen
	lda #CONGRATS_COLOR
	sta $0BCC,x
	inx
	cpx #$0D
	bne w1
	;
	jsr wait_for_key_release 
	;
	lda #win_key_table & 255
	ldx #win_key_table >> 8
	jmp keyboard

RevealSolution
	jsr wait_for_key_release
	;
	ldx #$FF				; sync to bottom of frame ($FF on PAL, $F8 on NTSC)
	lda $FF07
	and #$40
	beq *+4
	ldx #$F8
	cpx $FF1D
	bne *-3
	;
	lda #$42				; border and ECM to green
	sta $FF19
	sta $FF16
	;
	ldx #$00
rs1	ldy #$FF
	lda board_solution,x
	beq rs2
	ldy #$01
rs2	tya
	sta board_status,x
	inx
	bne rs1
	;
	jsr DisplayBoard
	;
	jsr wait_for_key_release 
	;
	lda #win_key_table & 255
	ldx #win_key_table >> 8
	jmp keyboard

wait_for_key_release
	lda #$02			; wait for ALL keys to be released (except shift lock)
	sta $FD30
	sta $FF08
	lda $FF08
	cmp #$FF
	bne wait_for_key_release
	;
wfkr1	lda #$FF
	sta $FD30
	lda #$FD
	sta $FF08
	lda $FF08
	cmp #$FF
	bne wfkr1
	;
wfkr2	lda #$FF
	sta $FD30
	lda #$FB
	sta $FF08
	lda $FF08
	cmp #$FF
	bne wfkr2
	;
null	rts
	
flash_menu
	inc flash_menu_delay+1
flash_menu_delay
	lda #$00
	and #$0F
	bne fm2
	;
	ldy #13
fm1	lda (menu_ptr),y
	eor #$10
	sta (menu_ptr),y
	dey
	bpl fm1
	;
fm2	rts

HighlightMenuItem
	lda boardsize
	sec
	sbc #$02
	tax
	lda mul14,x
	tax
	ldy #$00
mhi1	lda menu_levels,x
	sta CHARMEM+40*18+13,y
	inx
	iny
	cpy #13
	bne mhi1
	;
	lda #SELECTED_MENU_COLOR
	db $2C
ClearMenuItem
	lda #MENU_COLOR
	ldy #13
cmi1	sta (menu_ptr),y
	dey
	bpl cmi1
	rts

MenuUp
	lda boardsize				; already at top?
	cmp #2
	beq mnu1				; do nothing
	;
	jsr ClearMenuItem
	;
	dec boardsize				; go up
	;
	lda menu_ptr
	sec
	sbc #40
	sta menu_ptr
	bcs *+4
	dec menu_ptr+1
	;
	jsr HighlightMenuItem
	;
mnu1	jmp menu_loop

MenuDown
	lda boardsize				; already at bottom?
	cmp #9
	beq mnd1				; do nothing
	;
	jsr ClearMenuItem
	;
	inc boardsize				; go down
	;
	lda menu_ptr
	clc
	adc #40
	sta menu_ptr
	bcc *+4
	inc menu_ptr+1
	;
	jsr HighlightMenuItem
	;
mnd1	jmp menu_loop

MenuHome
	lda boardsize
	cmp #3
	beq mnh1
	;
	jsr ClearMenuItem
	;
	lda #MENU_POS & 255
	sta menu_ptr
	lda #MENU_POS >> 8
	sta menu_ptr+1
	lda #3
	sta boardsize
	;
	jsr HighlightMenuItem
	;
mnh1	jmp menu_loop

MenuSelect
	lda boardsize
	cmp #2
	beq info
	cmp #9
	beq game_exit
	jmp new_game

game_exit
	lda #$CC
	cmp $FF1D
	bne *-3
	;
	lda #$0B
	sta $FF06
	lda #$C4
	sta $FF12
	lda #$D1
	sta $FF13
	lda #$71
	sta $FF15
	;
	jsr wait_for_key_release
	;
	sta $FF3E
	cli
	;
	lda #$93
	jsr $FFD2
	;
	ldx #$FF				; sync to bottom of frame ($FF on PAL, $F8 on NTSC)
	lda $FF07
	and #$40
	beq *+4
	ldx #$F8
	cpx $FF1D
	bne *-3
	;
	lda #$6E
	sta $FF19
	lda #$1B
	sta $FF06
	;
	rts

info
	jsr wait_for_key_release
	;
	ldx #$FF				; sync to bottom of frame ($FF on PAL, $F8 on NTSC)
	lda $FF07
	and #$40
	beq *+4
	ldx #$F8
	cpx $FF1D
	bne *-3
	;
	lda #$5D				; screen off, set up all TED registers
	sta $FF19
	lda #$0B				
	sta $FF06
	lda #$00
	sta $FF15
	;
	ldy #$5D
	jsr ClearScreen
	;
	jsr CopyLogo
	;
	ldx #25
in1	lda info_text+ 0*26,x
	sta CHARMEM+(9+0)*40+7,x
	lda info_text+ 1*26,x
	sta CHARMEM+(9+1)*40+7,x
	lda info_text+ 2*26,x
	sta CHARMEM+(9+2)*40+7,x
	lda info_text+ 3*26,x
	sta CHARMEM+(9+3)*40+7,x
	lda info_text+ 4*26,x
	sta CHARMEM+(9+4)*40+7,x
	lda info_text+ 5*26,x
	sta CHARMEM+(9+5)*40+7,x
	lda info_text+ 6*26,x
	sta CHARMEM+(9+6)*40+7,x
	lda info_text+ 7*26,x
	sta CHARMEM+(9+7)*40+7,x
	lda info_text+ 8*26,x
	sta CHARMEM+(9+8)*40+7,x
	lda info_text+ 9*26,x
	sta CHARMEM+(9+9)*40+7,x
	lda info_text+ 10*26,x
	sta CHARMEM+(9+10)*40+7,x
	lda info_text+ 11*26,x
	sta CHARMEM+(9+11)*40+7,x
	dex
	bpl in1
	;
	lda #(COLORMEM+(9+0)*40+7) & 255
	sta col_ptr
	lda #(COLORMEM+(9+0)*40+7) >> 8
	sta col_ptr+1
	ldx #11
in3	ldy #25
in2	lda #INFO_COLOR
	sta (col_ptr),y
	dey
	bpl in2
	;
	lda col_ptr
	clc
	adc #40
	sta col_ptr
	bcc *+4
	inc col_ptr+1
	;
	dex
	bpl in3
	;
	lda #$CC				; sync to bottom of screen
	cmp $FF1D
	bne *-3
	;
	lda #$1B
	sta $FF06				; screen on (normal mode)
	;
	lda #info_key_table & 255
	ldx #info_key_table >> 8
	jmp keyboard

	include "key_constants.asm"

menu_key_table
	dw flash_menu
	;
	dw $0102, MenuUp			; Joystick 1
	dw $0202, MenuDown
	dw $8002, MenuSelect
	;
	dw $0104, MenuUp			; Joystick 2
	dw $0204, MenuDown
	dw $4004, MenuSelect
	;
	dw KEY_CURSOR_UP, MenuUp
	dw KEY_CURSOR_DOWN, MenuDown
	;
	dw KEY_CLEAR_HOME, MenuHome
	;
	dw KEY_SEMICOLON, MenuUp
	dw KEY_SLASH, MenuDown
	;
	dw KEY_RETURN, MenuSelect
	dw KEY_SPACE, MenuSelect
	;
	dw KEY_ESC, game_exit
	dw KEY_RUN_STOP, game_exit
	;
	dw 0

game_key_table
	dw flash_cursor
	;
	dw $0102, MoveUp			; Joystick 1
	dw $0202, MoveDown
	dw $0402, MoveLeft
	dw $0802, MoveRight
	dw $8002, ToggleTile
	;
	dw $0104, MoveUp			; Joystick 2
	dw $0204, MoveDown
	dw $0404, MoveLeft
	dw $0804, MoveRight
	dw $4004, ToggleTile
	;
	dw KEY_CURSOR_LEFT, MoveLeft
	dw KEY_CURSOR_RIGHT, MoveRight
	dw KEY_CURSOR_UP, MoveUp
	dw KEY_CURSOR_DOWN, MoveDown
	;
	dw KEY_CLEAR_HOME, MoveHome
	dw KEY_HELP, RevealSolution
	;
	dw KEY_Z, MoveLeft
	dw KEY_X, MoveRight
	dw KEY_SEMICOLON, MoveUp
	dw KEY_SLASH, MoveDown
	;
	dw KEY_RETURN, ToggleTile
	dw KEY_SPACE, ToggleTile
	;
	dw KEY_ESC, menu
	dw KEY_RUN_STOP, game_exit
	;
	dw 0

win_key_table
	dw null
	;
	dw $8002, new_game
	dw $4004, new_game
	dw KEY_RETURN, new_game
	dw KEY_SPACE, new_game
	;
	dw KEY_ESC, menu
	dw KEY_RUN_STOP, game_exit
	;
	dw 0

info_key_table
	dw null
	;
	dw $8002, menu
	dw $4004, menu
	dw KEY_RETURN, menu
	dw KEY_SPACE, menu
	;
	dw KEY_ESC, menu
	dw KEY_RUN_STOP, game_exit
	;
	dw 0

MoveLeft
	jsr ClearCursor
	;
	ldx cursor_x
	dex
	bpl *+5
	ldx boardsize
	dex
	stx cursor_x
	;
	jsr DrawCursor
	jmp main_loop

MoveRight
	jsr ClearCursor
	;
	ldx cursor_x
	inx
	cpx boardsize
	bne *+4
	ldx #$00
	stx cursor_x
	;
	jsr DrawCursor
	jmp main_loop

MoveUp
	jsr ClearCursor
	;
	ldy cursor_y
	dey
	bpl *+5
	ldy boardsize
	dey
	sty cursor_y
	;
	jsr DrawCursor
	jmp main_loop

MoveDown
	jsr ClearCursor
	;
	ldy cursor_y
	iny
	cpy boardsize
	bne *+4
	ldy #$00
	sty cursor_y
	;
	jsr DrawCursor
	jmp main_loop

MoveHome
	lda keyb_shift
	beq no_clear
	;
	ldx #$00
	lda #$00
mh1	sta board_status,x
	sta board_solution,x
	inx
	bne mh1
	;
	jsr DisplayBoard
	;
no_clear
	jsr ClearCursor
	;
	ldx #$00
	stx cursor_x
	ldy #$00
	sty cursor_y
	;
	jsr DrawCursor
	jmp main_loop	

ToggleTile
	lda cursor_y
	asl a
	asl a
	asl a
	asl a
	ora cursor_x
	tax
	lda board_status,x
	beq tt1
	bmi tt2
	lda #$80			; $80 = green circle
	db $2C
tt2	lda #$00			; 0 = clear
	db $2C
tt1	lda #$01			; 1 = red cross
	sta board_status,x
	;
	ldx cursor_x
	ldy cursor_y
	jsr DisplayTileXY
	;
	ldx cursor_x
	jsr CheckColumn
	;
	ldy cursor_y
	jsr CheckRow
	;
	jsr DrawCursor
	;
	jmp main_loop  
	
ClearBoard
	ldx #$00
	lda #$00
cb1	sta board,x
	sta board_status,x
	sta board_solution,x
	inx
	bne cb1
	;
	ldx #$0F
cb2	sta row_sums,x
	sta row_correct,x
	sta column_sums,x
	sta column_correct,x
	dex
	bpl cb2
	rts

GenerateBoard
	ldy #$00
gb3	ldx #$00
gb2	stx tmpx
	sty tmpy
	;
	tya
	asl a
	asl a
	asl a
	asl a
	ora tmpx
	tax
	;
gb1	jsr GetRandom
	lsr a
	and #$0F
	beq gb1
	cmp #$0A
	bcs gb1
	sta board,x
	lda #$00
	sta board_status,x
	jsr GetRandom
	and #$80
	sta board_solution,x
	;
	ldx tmpx
	ldy tmpy
	;
	inx
	cpx boardsize
	bne gb2
	iny
	cpy boardsize
	bne gb3
	rts

GetTilePtrs
	lda mul3,y
	clc
	adc board_y
	tay
	lda mul40_hi,y
	ora #$08
	sta col_ptr+1
	lda mul40_lo,y
	clc
	adc mul3,x
	bcc *+4
	inc col_ptr+1
	clc
	adc board_x
	bcc *+4
	inc col_ptr+1
	sta col_ptr
	sta chr_ptr
	lda col_ptr+1
	ora #$04
	sta chr_ptr+1
	rts 

dt1	lda #$20				; clear
	ldy #$00
	sta (chr_ptr),y
	iny
	sta (chr_ptr),y
	iny
	sta (chr_ptr),y
	ldy #40
	sta (chr_ptr),y
	iny
	lda #$11				; dark color
	sta (col_ptr),y 
	iny
	lda #$20
	sta (chr_ptr),y
	ldy #80
	sta (chr_ptr),y
	iny
	sta (chr_ptr),y
	iny
	sta (chr_ptr),y
	rts

ClearCursor
	ldx cursor_x
	ldy cursor_y
	;
DisplayTileXY
	stx tmpx
	sty tmpy
	;
DisplayTile
	jsr GetTilePtrs
	;
	lda tmpy
	asl a
	asl a
	asl a
	asl a
	ora tmpx
	tax
	;
	lda board,x
	ora #$30
	ldy #41
	sta (chr_ptr),y
	;
	lda board_status,x
	beq dt1
	bmi dt2
	;
	ldy #$00
	lda #$18				; cross
	sta (chr_ptr),y
	iny
	lda #$19
	sta (chr_ptr),y
	iny
	lda #$1A
	sta (chr_ptr),y
	ldy #40
	lda #$1B
	sta (chr_ptr),y
	iny
	lda #$41
	sta (col_ptr),y 			; faded color
	iny
	lda #$1C
	sta (chr_ptr),y
	ldy #80
	lda #$1D
	sta (chr_ptr),y
	iny
	lda #$1E
	sta (chr_ptr),y
	iny
	lda #$1F
	sta (chr_ptr),y
	;
	lda #$52
	bne dt3
	;
dt2	ldy #$00
	lda #$10				; circle
	sta (chr_ptr),y
	iny
	lda #$11
	sta (chr_ptr),y
	iny
	lda #$12
	sta (chr_ptr),y
	ldy #40
	lda #$13
	sta (chr_ptr),y
	iny
	lda #$00				; solid color
	sta (col_ptr),y 
	iny
	lda #$14
	sta (chr_ptr),y
	ldy #80
	lda #$15
	sta (chr_ptr),y
	iny
	lda #$16
	sta (chr_ptr),y
	iny
	lda #$17
	sta (chr_ptr),y
	;
	lda #$35
dt3	sta (col_ptr),y
	dey
	sta (col_ptr),y
	dey
	sta (col_ptr),y
	ldy #40
	sta (col_ptr),y
	iny
	iny
	sta (col_ptr),y
	ldy #0
	sta (col_ptr),y
	iny
	sta (col_ptr),y
	iny
	sta (col_ptr),y
dtx	rts

DrawBorder
	lda boardsize
	cmp #$08				; at 8x8, the border doesn't fit, don't draw it
	beq dtx
	;
	ldx board_x
	dex
	txa
	ldy board_y
	dey
	clc
	adc mul40_lo,y
	sta col_ptr
	sta chr_ptr
	lda mul40_hi,y
	adc #$08
	sta col_ptr+1
	ora #$04
	sta chr_ptr+1
	;
	ldy #$00
	lda #$4B
	sta (chr_ptr),y
	lda #BORDER_COLOR
	sta (col_ptr),y
	;
	ldx boardsize
	lda mul3,x
	sta tmpx
	tax
drb2	iny
	lda #$4C
	sta (chr_ptr),y
	lda #BORDER_COLOR
	sta (col_ptr),y
	dex
	bne drb2
	;
	iny
	lda #$4D
	sta (chr_ptr),y
	lda #BORDER_COLOR
	sta (col_ptr),y
	;
	sty tmpy
	;
	ldx tmpx
drb3	lda col_ptr
	clc
	adc #40
	sta col_ptr
	sta chr_ptr
	bcc *+6
	inc col_ptr+1
	inc chr_ptr+1
	;
	ldy #$00
	lda #$4E
	sta (chr_ptr),y
	lda #BORDER_COLOR
	sta (col_ptr),y
	ldy tmpy
	lda #$4F
	sta (chr_ptr),y
	lda #BORDER_COLOR
	sta (col_ptr),y
	;
	dex
	bne drb3
	;
	; ---
	;
	lda col_ptr
	clc
	adc #40
	sta col_ptr
	sta chr_ptr
	bcc *+6
	inc col_ptr+1
	inc chr_ptr+1
	;
	ldy #$00
	lda #$7D
	sta (chr_ptr),y
	lda #BORDER_COLOR
	sta (col_ptr),y
	;
	ldx boardsize
	lda mul3,x
	sta tmpx
	tax
drb4	iny
	lda #$7E
	sta (chr_ptr),y
	lda #BORDER_COLOR
	sta (col_ptr),y
	dex
	bne drb4
	;
	iny
	lda #$7F
	sta (chr_ptr),y
	lda #BORDER_COLOR
	sta (col_ptr),y 
	;
drb1	rts

DisplayBoard
	ldy #$00
db3	ldx #$00
db2	stx tmpx
	sty tmpy
	;
	jsr DisplayTile
	;
	ldx tmpx
	ldy tmpy
	;
	inx
	cpx boardsize
	bne db2
	iny
	cpy boardsize
	bne db3
	;
	ldx #$00
db4	jsr CheckColumn
	ldx tmpx
	inx
	cpx boardsize
	bne db4
	;
	ldy #$00
db5	jsr CheckRow
	ldy tmpy
	iny
	cpy boardsize
	bne db5
	;
	rts
	
CheckColumn
	stx tmpx
	;
	lda #$00
	sta sum
	;
	ldy boardsize
	;
cc1	lda board_status,x
	cmp #$01				; x?
	beq cc2
	;
	sed
	lda sum
	clc
	adc board,x
	sta sum
	cld
	;
cc2	txa
	clc
	adc #16
	tax
	;
	dey
	bne cc1
	;
	ldx tmpx
	ldy boardsize
	jsr GetTilePtrs
	;
	ldy #$00				; column is correct flag
	ldx tmpx
	lda column_sums,x
	cmp sum
	beq cc3
	;
	ldy #$FF				; column is incorrect
	lda #INCORRECT_SUM_COLOR		; faded color
	db $2C
cc3	lda #CORRECT_SUM_COLOR
	;
	pha
	;
	tya
	sta column_correct,x 			; flag the column are correct/incorrect
	;
	lda boardsize
	cmp #$08
	bne cc4
	ldy #0
	db $2C
cc4	ldy #40
	pla
	sta (col_ptr),y
	iny
	sta (col_ptr),y
	;
	rts

SumColumns
	ldx #$00
scs1	stx tmpx
	jsr SumColumn
	ldx tmpx
	lda sum
	sta column_sums,x
	inx
	cpx boardsize
	bne scs1
	rts

SumColumn
	lda #$00
	sta sum
	;
	ldy boardsize
	;
sc1	lda board_solution,x
	bne sc2
	;
	sed
	lda sum
	clc
	adc board,x
	sta sum
	cld
	;
sc2	txa
	clc
	adc #16
	tax
	;
	dey
	bne sc1
	;
	ldx tmpx
	ldy boardsize
	jsr GetTilePtrs
	;
	lda boardsize
	cmp #$08
	bne sc4
	ldy #0
	db $2C
sc4	ldy #40
	;
	lda sum
	lsr a
	lsr a
	lsr a
	lsr a
	beq sc3
	ora #$40
	sta (chr_ptr),y
sc3	iny
	lda sum
	and #$0F
	ora #$40
	sta (chr_ptr),y
	;
	rts
	
CheckRow
	sty tmpy
	;
	lda #$00
	sta sum
	;
	ldx boardsize
	;
	tya
	asl a
	asl a
	asl a
	asl a
	tay
	;
cr1	lda board_status,y
	cmp #$01				; x?
	beq cr2
	;
	sed
	lda sum
	clc
	adc board,y
	sta sum
	cld
	;
cr2	iny
	;
	dex
	bne cr1
	;
	ldx boardsize
	ldy tmpy
	jsr GetTilePtrs
	;
	ldx #$00				; flag row as correct
	ldy tmpy
	lda row_sums,y
	cmp sum
	beq cr3
	;
	ldx #$FF				; incorrect
	lda #INCORRECT_SUM_COLOR		; faded color
	db $2C
cr3	lda #CORRECT_SUM_COLOR
	ldy #41
	sta (col_ptr),y
	iny
	sta (col_ptr),y
	;
	ldy tmpy
	txa
	sta row_correct,y			; flag row as correct/incorrect
	;
	rts

SumRows
	ldy #$00
srs1	sty tmpy
	jsr SumRow
	ldy tmpy
	lda sum
	sta row_sums,y
	iny
	cpy boardsize
	bne srs1
	rts

SumRow
	lda #$00
	sta sum
	;
	ldx boardsize
	;
	tya
	asl a
	asl a
	asl a
	asl a
	tay
	;
sr1	lda board_solution,y
	bne sr2
	;
	sed
	lda sum
	clc
	adc board,y
	sta sum
	cld
	;
sr2	iny
	;
	dex
	bne sr1
	;
	ldx boardsize
	ldy tmpy
	jsr GetTilePtrs
	;
	ldy #41
	lda sum
	lsr a
	lsr a
	lsr a
	lsr a
	beq sr3
	ora #$40
	sta (chr_ptr),y
sr3	iny
	lda sum
	and #$0F
	ora #$40
	sta (chr_ptr),y
	;
	rts

CheckWin
	ldx #$00
	lda #$00
cw1	ora row_correct,x
	ora column_correct,x
	inx
	cpx boardsize
	bne cw1
	;
	cmp #$00				; return "win flag" in Z
	rts

DrawCursor
	ldx cursor_x
	ldy cursor_y
	jsr GetTilePtrs
	;
	ldx #$02
dc1	ldy #$02
dc2	lda (chr_ptr),y
	and #$3F
	ora #$80
	sta (chr_ptr),y
	dey
	bpl dc2
	;
	lda chr_ptr
	clc
	adc #40
	sta chr_ptr
	bcc *+4
	inc chr_ptr+1
	;
	dex
	bpl dc1
	rts

flash_cursor
	inc flash_cursor_delay+1
flash_cursor_delay
	lda #$00
	and #$0F
	bne fc1
	lda $FF17
	eor #($50^$60)
	sta $FF17
fc1	rts

	cmap " ",$40
	cmap "0",$60,$61,$62,$63,$64,$65,$66,$67,$68,$69
	cmap "A",$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F
	cmap "P",$50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A
	cmap "*",$5C
	cmap ":",$6A
	cmap ".",$6B
	cmap "+",$6C
	cmap "-",$6D
menu_text
	db "     INFO     "
	db "   PLAY 3*3   "
	db "   PLAY 4*4   "
	db "   PLAY 5*5   "
	db "   PLAY 6*6   "
	db "   PLAY 7*7   "
	db "   PLAY 8*8   "
	db "     QUIT     "
menu_levels
	db "              "
	db "   BEGINNER   "
	db "     EASY     "
	db " INTERMEDIATE "
	db " CHALLENGING  "
	db "   ADVANCED   "
	db "    EXPERT    "
	db "              "

copyright
	db "CSABO 2023"

info_text
	;  |0123456789012345678901234|
	db "                          "
	db " DELETE NUMBERS SO EACH   "
	db " ROW AND COLUMN ADDS UP   "
	db " TO THE TARGET NUMBER AT  "
	db " THE RIGHT AND BOTTOM.    "
	db "                          "
	db " CONTROLS:                "
	db " CURSOR : MOVE            "
	db " SPACE  : TOGGLE NUMBER   "
	db " ESC    : QUIT TO MENU    "
	db " HELP   : REVEAL SOLUTION "
	db "                          "
	cmap
mul14
	db 0*14
	db 1*14
	db 2*14
	db 3*14
	db 4*14
	db 5*14
	db 6*14

mul3
	db 0,3,6,9,12,15,18,21,24

mul40_lo
	db (0*40) & 255
	db (1*40) & 255
	db (2*40) & 255
	db (3*40) & 255
	db (4*40) & 255
	db (5*40) & 255
	db (6*40) & 255
	db (7*40) & 255
	db (8*40) & 255
	db (9*40) & 255
	db (10*40) & 255
	db (11*40) & 255
	db (12*40) & 255
	db (13*40) & 255
	db (14*40) & 255
	db (15*40) & 255
	db (16*40) & 255
	db (17*40) & 255
	db (18*40) & 255
	db (19*40) & 255
	db (20*40) & 255
	db (21*40) & 255
	db (22*40) & 255
	db (23*40) & 255
	db (24*40) & 255
	db (24*40) & 255

mul40_hi
	db (0*40) >> 8
	db (1*40) >> 8
	db (2*40) >> 8
	db (3*40) >> 8
	db (4*40) >> 8
	db (5*40) >> 8
	db (6*40) >> 8
	db (7*40) >> 8
	db (8*40) >> 8
	db (9*40) >> 8
	db (10*40) >> 8
	db (11*40) >> 8
	db (12*40) >> 8
	db (13*40) >> 8
	db (14*40) >> 8
	db (15*40) >> 8
	db (16*40) >> 8
	db (17*40) >> 8
	db (18*40) >> 8
	db (19*40) >> 8
	db (20*40) >> 8
	db (21*40) >> 8
	db (22*40) >> 8
	db (23*40) >> 8
	db (24*40) >> 8
	db (24*40) >> 8

board_xs
	db (40-3-0*3)/2
	db (40-3-1*3)/2
	db (40-3-2*3)/2
	db (40-3-3*3)/2
	db (40-3-4*3)/2
	db (40-3-5*3)/2
	db (40-3-6*3)/2
	db (40-3-7*3)/2
	db (40-3-8*3)/2
	db (40-3-9*3)/2
board_ys
	db (25-2-0*3)/2
	db (25-2-1*3)/2
	db (25-2-2*3)/2
	db (25-2-3*3)/2
	db (25-2-4*3)/2
	db (25-2-5*3)/2
	db (25-2-6*3)/2
	db (25-2-7*3)/2
	db (25-2-8*3)/2
	db (25-2-9*3)/2

	include "random.asm"
	
	include "keyboard.asm"
	
charmap	; (40*25)
	db $70,$71,$72,$73,$74,$73,$70,$71,$75,$71,$72,$76,$77,$72,$73,$74
	db $74,$76,$78,$79,$7A,$7B,$79,$76,$78,$79
	db $7C,$74,$7D,$7E,$74,$7E,$7F,$74,$80,$74,$81,$7E,$74,$82,$7E,$74
	db $74,$7E,$74,$74,$74,$7E,$74,$7E,$74,$74
	db $83,$84,$72,$7E,$74,$7E,$7E,$74,$7E,$74,$7E,$85,$86,$87,$7E,$74
	db $74,$85,$79,$74,$74,$7E,$74,$85,$79,$74
	db $88,$89,$8A,$8B,$89,$8C,$7E,$74,$7E,$74,$7E,$7E,$74,$74,$7E,$74
	db $74,$7E,$74,$74,$74,$7E,$74,$7E,$74,$74
	db $83,$8D,$87,$83,$8D,$87,$8E,$74,$8E,$74,$8E,$8E,$74,$74,$8F,$78
	db $79,$8F,$78,$79,$74,$8E,$74,$8F,$78,$79
	
	align $0800
font
	include "font.asm"

board
	ds $100
board_status
	ds $100
board_solution
	ds $100
row_sums
	ds 16
row_correct
	ds 16
column_sums
	ds 16
column_correct
	ds 16
;eof